<template>
    <div class="edit-view">
        <page-title>
            <el-button @click="$router.go(-1)" :disabled="saving">取消</el-button>
            <el-button @click="onDelete" :disabled="saving" type="danger" v-if="formData.id">
                删除
            </el-button>
            <el-button @click="reply" :loading="saving" type="primary">回复</el-button>
        </page-title>
        <div class="edit-view__content-wrapper">
            <div class="edit-view__content-section">
                <el-form
                    :model="formData"
                    :rules="rules"
                    ref="form"
                    label-width="80px"
                    label-position="right"
                    size="small"
                    style="max-width: 500px;"
                >
                    <el-form-item prop="name" label="姓名">
                        <el-input v-model="formData.name" readonly></el-input>
                    </el-form-item>
                    <el-form-item prop="occupation" label="职业">
                        <el-input v-model="formData.occupation" readonly></el-input>
                    </el-form-item>
                    <el-form-item prop="phone" label="电话">
                        <el-input v-model="formData.phone" readonly></el-input>
                    </el-form-item>
                    <el-form-item prop="email" label="邮箱">
                        <el-input v-model="formData.email" readonly></el-input>
                    </el-form-item>
                    <el-form-item prop="type" label="证件类型">
                        <el-radio-group v-model="formData.type">
                            <el-radio v-for="item in typeOptions" :key="item.value" :label="item.value" disabled>
                                {{ item.label }}
                            </el-radio>
                        </el-radio-group>
                    </el-form-item>
                    <el-form-item prop="documentNumber" label="证件编号">
                        <el-input v-model="formData.documentNumber" readonly></el-input>
                    </el-form-item>
                    <el-form-item prop="title" label="咨询标题">
                        <el-input v-model="formData.title" readonly></el-input>
                    </el-form-item>
                    <el-form-item prop="content" label="正文详情">
                        <el-input type="textarea" :rows="4" v-model="formData.content" readonly></el-input>
                    </el-form-item>
                    <el-form-item prop="img" label="图片">
                        <multi-upload v-model="formData.img"></multi-upload>
                    </el-form-item>
                    <el-form-item prop="reply" label="回复">
                        <el-radio-group v-model="formData.reply">
                            <el-radio :label="true" disabled>已回复 </el-radio>
                            <el-radio :label="false" disabled>未回复 </el-radio>
                        </el-radio-group>
                    </el-form-item>
                    <el-form-item prop="replyContent" label="回复内容">
                        <el-input
                            type="textarea"
                            :rows="4"
                            v-model="formData.replyContent"
                            :readonly="formData.reply"
                        ></el-input>
                    </el-form-item>
                </el-form>
            </div>
        </div>
    </div>
</template>
<script>
import { phonePattern } from '../utils/variables';
export default {
    name: 'MessageEdit',
    created() {
        if (this.$route.query.id) {
            this.$http
                .get('message/get/' + this.$route.query.id)
                .then(res => {
                    this.formData = res;
                })
                .catch(e => {
                    console.log(e);
                    this.$message.error(e.error);
                });
        }
    },
    data() {
        return {
            saving: false,
            formData: {},
            rules: {
                name: [{ required: true, message: '请输入姓名' }],
                occupation: [{ required: true, message: '请输入职业' }],
                type: [{ required: true, message: '请选择证件类型' }],
                documentNumber: [{ required: true, message: '请输入证件编号', trigger: 'blur' }],
                title: [{ required: true, message: '请输入咨询标题' }],
                content: [{ required: true, message: '请填写正文详情' }],
                email: [{ type: 'email', required: true, message: '请输入邮箱', trigger: 'blur' }],
                img: [{ required: true, message: '请添加图片', trigger: 'blur' }],
                phone: { required: true, pattern: phonePattern, message: '请输入联系电话', trigger: 'blur' },
                reply: [{ required: true, message: '请选择回复', trigger: 'blur' }],
                replyContent: [{ required: true, message: '请输入回复内容' }]
            },
            typeOptions: [
                { label: '身份证', value: 'ID_CARD' },
                { label: '军官证', value: 'OFFICER_ID' }
            ]
        };
    },
    methods: {
        onSave() {
            this.$refs.form.validate(valid => {
                if (valid) {
                    this.submit();
                } else {
                    return false;
                }
            });
        },
        submit() {
            let data = { ...this.formData };

            this.saving = true;
            this.$http
                .post('/message/save', data, { body: 'json' })
                .then(res => {
                    this.saving = false;
                    this.$message.success('成功');
                    this.$router.go(-1);
                })
                .catch(e => {
                    console.log(e);
                    this.saving = false;
                    this.$message.error(e.error);
                });
        },
        reply() {
            let data = this.formData.replyContent;
            let id = this.$route.query.id;

            this.saving = true;
            this.$http
                .post('/message/reply', { id: id, content: data })
                .then(res => {
                    this.saving = false;
                    this.$message.success('成功');
                    this.$router.go(-1);
                })
                .catch(e => {
                    console.log(e);
                    this.saving = false;
                    this.$message.error(e.error);
                });
        },
        onDelete() {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' })
                .then(() => {
                    return this.$http.post(`/message/del/${this.formData.id}`);
                })
                .then(() => {
                    this.$message.success('删除成功');
                    this.$router.go(-1);
                })
                .catch(e => {
                    if (e !== 'cancel') {
                        console.log(e);
                        this.$message.error((e || {}).error || '删除失败');
                    }
                });
        }
    }
};
</script>
<style lang="less" scoped>
/deep/ .el-radio__input.is-disabled + span.el-radio__label {
    color: #606266;
}
/deep/ .el-radio__input.is-disabled.is-checked .el-radio__inner {
    border-color: #409eff;
    background: #409eff;
    color: #606266;
}
/deep/ .el-radio__input.is-disabled.is-checked + .el-radio__label {
    color: #409eff;
}
</style>
